/*
 * cc -o chain chain.c
 * cc -n32 -o chain chain.c
 * cc -64 -Ofast -o chain chain.c
 * 
 * chain <getal>
 * chain 10
 * 
 */

#include <stdio.h>

#define MAXL 2100
#define MAXLLL 25
#define MAZE 5
#define FILENAME "chain.out"

int LL[MAXL+1][MAXL+1];
int DD[MAXL+1][MAXL+1];
int L[MAXL+1];

void binary( long m, int *e_0, int *e_1)
{
  int c0 = 0, 
      c1 = 0;
  
  while (m)
  {
    if (m % 2) 
      c1++;
    else
      c0++;
    m /= 2;
  }
  *e_0 = c0;
  *e_1 = c1;
}

void calcLLL(int *LLL, int len, int in_DD, int in_LL, int *out_DD, int *out_LL)
{
  int b,
      i,
      j,
      k,
      x,
      new_len = len,
      DDvalue = in_DD,
      LLvalue = in_LL,
      DDnew,
      LLnew,
      new_LLL[MAXLLL+1];
  char c;

  if (len >= MAXLLL)
  {
    printf("Out of resources for length %d (", len);
    for (i = 1; i < len; i++)
      printf("%d,", LLL[i]);
    printf("%d)\n", LLL[len]);
    return;
  }
  
  if ((DDvalue > LLvalue) || (LLvalue <= 0))
  {
    printf("%d <= (", DDvalue);
    for (i = 1; i < len; i++)
      printf("%d,", LLL[i]);
    printf("%d) <= %d\t==>exit...\n", LLL[len], in_LL);
    return;
  }
  
  if (len == 2)
  {
    *out_LL = LL[LLL[1]][LLL[2]];
    *out_DD = LL[LLL[1]][LLL[2]];
    return; 
  }

  for (i = 1; i < len; i++)
    if (LL[LLL[i]][LLL[len]] > DDvalue)
    {
      DDvalue = LL[LLL[i]][LLL[len]];
      if (DDvalue >= LLvalue)
      {
        *out_DD = DDvalue;
        *out_LL = LLvalue;
        return;
      }
    }

  if (LLL[len] - LLL[len-1] < 3)
  {
    calcLLL(LLL, len - 1, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    *out_DD = DDnew + 1;
    *out_LL = LLnew + 1;
    return;
  }

  if (LLL[len] % LLL[len-1] == 0)
  {
    x = L[LLL[len] / LLL[len-1]];
    calcLLL(LLL, len - 1, DDvalue - x, LLvalue - x, &DDnew, &LLnew);
    if (LLnew + x < LLvalue)
    {
      LLvalue = LLnew + x;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + x;
        *out_LL = LLnew + x;
        return;
      }
    }
  }

  j = len - 1;
  while ((2 * LLL[j] >= LLL[len]) && (j > 0))
  {
    i = 1;
    while (LLL[i] + LLL[j] < LLL[len])
      i++;
    if (LLL[len] == LLL[i] + LLL[j])
    {
      calcLLL(LLL, len - 1, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
      *out_DD = DDnew + 1;
      *out_LL = LLnew + 1;
      return;
    }
    j--;
  }

  for (i = 1; i < len - 1; i++)
    for (j = i + 1; j < len; j++)
    {
      if ((2 * LLL[j] < LLL[j+1]) && 
          (LL[LLL[i]][LLL[j]] + len - j + 1 > DDvalue))
      {
        DDvalue = LL[LLL[i]][LLL[j]] + len - j + 1;
        if (DDvalue >= LLvalue)
        {
          *out_LL = LLvalue;
          *out_DD = DDvalue;
          return;
        }
      }
      else if (LL[LLL[i]][LLL[j]] + len - j > DDvalue)
      {
        DDvalue = LL[LLL[i]][LLL[j]] + len - j;
        if (DDvalue >= LLvalue)
        {
          *out_LL = LLvalue;
          *out_DD = DDvalue;
          return;
        }
      }
    }

  if ((LLL[2] > 2 * LLL[1]) && (L[LLL[1]] + len > DDvalue))
  {
    DDvalue = L[LLL[1]] + len;
    if (DDvalue >= LLvalue)
    {
      *out_LL = LLvalue;
      *out_DD = DDvalue;
      return;
    }
  }
  else if (L[LLL[1]] + len - 1 > DDvalue)
  {
    DDvalue = L[LLL[1]] + len - 1;
    if (DDvalue >= LLvalue)
    {
      *out_LL = LLvalue;
      *out_DD = DDvalue;
      return;
    }
  }

  for (i = 2; i < len; i++)
    for (j = 1; j < i; j++)
    {
      if ((LLL[i+1] > 2 * LLL[i]) &&
          (LL[LLL[j]][LLL[i]] + len - i + 1 > DDvalue))
      {
        DDvalue = LL[LLL[j]][LLL[i]] + len - i + 1;
        if (DDvalue >= LLvalue)
        {
          *out_LL = LLvalue;
          *out_DD = DDvalue;
          return;
        }
      }
      else if (LL[LLL[j]][LLL[i]] + len - i > DDvalue)
      {
        DDvalue =  LL[LLL[j]][LLL[i]] + len - i;
        if (DDvalue >= LLvalue)
        {
          *out_LL = LLvalue;
          *out_DD = DDvalue;
          return;
        }
      }
    }

  if (LLL[len] % 2 == 0)
  {
    i = 1;
    j = 1;
    while (2 * LLL[i] < LLL[len])
    {
      new_LLL[j] = LLL[i];
      i++;
      j++;
    }
    new_LLL[j] = LLL[len] / 2;
    j++;
    if (2 * LLL[i] == LLL[len])
      i++;
    while (i < len)
    {
      new_LLL[j] = LLL[i];
      i++;
      j++;
    }
    new_len = j - 1;
    calcLLL(new_LLL, new_len, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    if (LLnew + 1 < LLvalue)
    {
      LLvalue = LLnew + 1;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + 1;
        *out_LL = LLnew + 1;
        return;
      }
    }
          
    for (i = 1; i < len; i++)
      new_LLL[i] = LLL[i];
    new_LLL[len] = LLL[len] - 2;

    calcLLL(new_LLL, len, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    if (LLnew + 1 < LLvalue)
    {
      LLvalue = LLnew + 1;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + 1;
        *out_LL = LLnew + 1;
        return;
      }
    }

    new_LLL[len] = LLL[len] - 1;

    calcLLL(new_LLL, len, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    if (LLnew + 1 < LLvalue)
    {
      LLvalue = LLnew + 1;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + 1;
        *out_LL = LLnew + 1;
        return;
      }
    }
  }
  else
  {
    for (i = 1; i < len; i++)
      new_LLL[i] = LLL[i];

    new_LLL[len] = LLL[len] - 1;

    calcLLL(new_LLL, len, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    if (LLnew + 1 < LLvalue)
    {
      LLvalue = LLnew + 1;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + 1;
        *out_LL = LLnew + 1;
        return;
      }
    }

    new_LLL[len] = LLL[len] - 2;

    calcLLL(new_LLL, len, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    if (LLnew + 1 < LLvalue)
    {
      LLvalue = LLnew + 1;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + 1;
        *out_LL = LLnew + 1;
        return;
      }
    }
  }

  for (x = 3; x <= (LLL[len] - 1) / 2; x++)
  {
    i = 1;
    j = 1;
    while (LLL[i] < x)
    {
      new_LLL[j] = LLL[i];
      i++;
      j++;
    }
    new_LLL[j] = x;
    j++;
    if (LLL[i] == x)
      i++;
    while (LLL[i] < LLL[len] - x)
    {
      new_LLL[j] = LLL[i];
      i++;
      j++;
    }
    new_LLL[j] = LLL[len] - x;
    j++;
    if (LLL[i] == LLL[len] - x)
      i++;
    while (i < len)
    {
      new_LLL[j] = LLL[i];
      i++;
      j++;
    }
    new_len = j - 1;

    calcLLL(new_LLL, new_len, DDvalue - 1, LLvalue - 1, &DDnew, &LLnew);
    if (LLnew + 1 < LLvalue)
    {
      LLvalue = LLnew + 1;
      if (LLvalue == DDvalue)
      {
        *out_DD = DDnew + 1;
        *out_LL = LLnew + 1;
        return;
      }
    }
  }

  if (LLvalue - DDvalue)
    DDvalue++;
  *out_LL = LLvalue;
  *out_DD = DDvalue;
  return; 
}

int calcLLModBrun(int x,int y)
{
  if (y < 4)
    return y - 1;
  if (y % x == 0)
    return L[x] + L[y/x];
  return LL[y%x][x] + L[y/x] + 1;
}

void main(int argc, char* argv[])
{
  int to, k, kk, x, xx, y, LLvalue, DDvalue, DDnew, LLnew;
  int LLL[MAXLLL+1], pref[MAXL];
  char c;
  FILE *fpout;

  printf("Table with length of chains via x and y\n\n");

  if (argc == 1)
    to = 30;
  else
    to = atoi(argv[1]);

  if (to > MAXL)
    to = MAXL;
  for (x = 1; x <= MAXL; x++)
    for (y = 1; y <= MAXL; y++)
    {
      LL[x][y] = 0;
      LL[x][y] = 0;
      DD[x][y] = 0;
    }

  L[1] = 0;
  L[2] = 1;
  LL[1][2] = 1;
  DD[1][2] = 1;

  printf("status:    2\n");
  for (y = 3; y <= to; y++)
  {
    printf("\b\b\b\b%4d", y);
    fflush(stdout);
    if (y % 2 == 0)
    {
      L[y] = L[y/2] + 1;
      if (L[y] > L[y-2] + 1)
        L[y] = L[y-2] + 1;
      if (L[y] > L[y-1] + 1)
        L[y] = L[y-1] + 1;
    }
    else
    {
      L[y] = L[y-1] + 1;
      if ((L[y] > L[y-2] + 1) && ( y > 3))
        L[y] = L[y-2] + 1;
    }
    /*preference list*/
    for (k = 1; k < (y - 1) / 2 - 1; k++)
      pref[k] = k + 2;
    if (y % 7 == 0)
    {
      for (k = y / 7 - 2; k > 1; k --)
        pref[k] = pref[k-1];
      pref[1] = y / 7;
    }
    if (y % 5 == 0)
    {
      for (k = y / 5 - 2; k > 1; k --)
        pref[k] = pref[k-1];
      pref[1] = y / 5;
    }
    if (y % 3 == 0)
    {
      for (k = y / 3 - 2; k > 1; k --)
        pref[k] = pref[k-1];
      pref[1] = y / 3;
    }
    
    for (k = 1; k < (y - 1) / 2 - 1; k++)
    {
      x = pref[k];
      if (LL[x][y-x] + 1 < L[y])
        L[y] = LL[x][y-x] + 1;
    }
    LL[y-2][y] = L[y-2] + 1;
    LL[y-1][y] = L[y-1] + 1;
    LL[1][y] = L[y];
    LL[2][y] = L[y];
    DD[y-2][y] = L[y-2] + 1;
    DD[y-1][y] = L[y-1] + 1;
    DD[1][y] = L[y];
    DD[2][y] = L[y];
    if (y % 2 == 0)
    {
      LL[y/2][y] = L[y/2] + 1;
      DD[y/2][y] = L[y/2] + 1;   
    }
    for (x = 3; x < y - 2; x++)
      if (2 * x - y)
      {
        DD[x][y] = L[y];
        LL[x][y] = calcLLModBrun(x,y);
        if (L[x] + 1 > DD[x][y])
          DD[x][y] = L[x] + 1;
        if (y % 2 == 0)
        {
          if (LL[x][y/2] + LL[y/2][x] + 1 < LL[x][y])
            LL[x][y] = LL[x][y/2] + LL[y/2][x] + 1;
          if (LL[x][y-2] + 1 < LL[x][y])
            LL[x][y] = LL[x][y-2] + 1;
          if (LL[x][y-x] + LL[y-x][x] + 1 < LL[x][y])
            LL[x][y] = LL[x][y-x] + LL[y-x][x] + 1;
          if (LL[x][y-1] + 1 < LL[x][y])
            LL[x][y] = LL[x][y-1] + 1;
        }
        else
        {
          if (LL[x][y-1] + 1 < LL[x][y])
            LL[x][y] = LL[x][y-1] + 1;
          if (LL[x][y-x] + LL[y-x][x] + 1 < LL[x][y])
            LL[x][y] = LL[x][y-x] + LL[y-x][x] + 1;
          if (LL[x][y-2] + 1 < LL[x][y])
            LL[x][y] = LL[x][y-2] + 1;
        }
        if ((4 * x < y) && (L[x] + 3 > DD[x][y]))
          DD[x][y] = L[x] + 3;
        if ((2 * x < y) && (L[x] + 2 > DD[x][y]))
          DD[x][y] = L[x] + 2;
        
        while (DD[x][y] < LL[x][y])
        {
          for (kk = 1; kk <= (y - 1) / 2 - 2; kk++)
          {
            xx = pref[kk];
            if ((xx - x) && (x + xx - y) && (DD[x][y] < LL[x][y]) &&
                (LL[xx][y-xx] + 1 < LL[x][y]) && 
            (LL[x][y-xx] + LL[y-xx][x] + 1 < LL[x][y]))
            {
              LLL[1] = ((xx < x) ? ((2 * xx < y) ? xx : y - xx) : 
                                    ((x + xx < y) ? x : y - xx));
              LLL[3] = ((xx > x) ? ((2 * xx > y) ? xx : y - xx) : 
                                    ((x + xx > y) ? x : y - xx));
              LLL[2] = y + x - LLL[1] - LLL[3];
              DDvalue = DD[x][y] - 1;
              LLvalue = LL[x][y] - 1;
              calcLLL(LLL, 3, DD[x][y] - 1, LL[x][y] - 1, &DDnew, &LLnew);
              if (LLnew + 1 < LL[x][y])
              {
                LL[x][y] = LLnew + 1;
              }
            }
          }
          if (DD[x][y] < LL[x][y])
            DD[x][y]++;
        }
        if (LL[x][y] < L[y])
        {
          printf("An impossibility! LL(%d,%d) = %d < %d = L(%d)\n", 
              x, y, LL[x][y], L[y], y);
          return;
        }
      }
  }
  if (!(fpout = fopen(FILENAME, "w")))
  {
    printf("Error, Outputfile cannot be opened\n");
    return;
  }
  fprintf(fpout, "  n L(n) LL(m,n) - L(n)\n\n  2    1 0\n");
  for (y = 3; y <= to; y++)
  {
    fprintf(fpout, "%3d %4d ", y, L[y]);
    for (x = 1; x < y; x++)
      fprintf(fpout, "%d", LL[x][y] - L[y]);
    fprintf(fpout, "\n");
  }
  fclose(fpout);
  printf("\nready\n");
}  
